:- use_module(library(lists)).

writeall([],_,_).
writeall([X|R],Prefix,Postfix) :-
    write(Prefix),
    write(X),
    writeln(Postfix),
    writeall(R,Prefix,Postfix).

loadfiles :-
    [solution], % If needed, edit your name file here
    [mainarizumufacts].

withDifferentFacts(Goal) :-
    ([mainarizumufacts2]),
    (Goal ->
      [mainarizumufacts];
      [mainarizumufacts]).

test_assignment_1 :-
    writeln('%%%%%%% Assignment 1'),
    maximalChains(Ch),
    (sort(Ch, [chain([ (0, 3), (0, 2), (1, 2)]), chain([ (0, 4), (1, 4), (1, 3)]), chain([ (2, 0), (1, 0)]), chain([ (2, 1), (3, 1)]), chain([ (2, 3), (2, 2)]), chain([ (2, 4), (3, 4)])])->
      writeln(yes);
      writeln(no)),
    withDifferentFacts(test_assignment_1_different_grid).


test_assignment_1_different_grid :-
    writeln('Testing with the 6 by 6 grid'),
    maximalChains(Ch2),
    (sort(Ch2, [chain([ (1, 3), (2, 3), (2, 2), (1, 2)]), chain([ (1, 3), (2, 3), (2, 2), (3, 2)]), chain([ (3, 3), (2, 3), (2, 2), (1, 2)]), chain([ (3, 3), (2, 3), (2, 2), (3, 2)])])->
      writeln(yes);
      writeln(no)).


test_assignment_2 :-
    writeln('%%%%%%% Assignment 2'),
    findall(Sol, mainarizumu(Sol), Sols),
    (Sols = [Sol]->
      (sort(Sol, [at(0, 0, 2), at(0, 1, 1), at(0, 2, 4), at(0, 3, 5), at(0, 4, 3), at(1, 0, 4), at(1, 1, 5), at(1, 2, 3), at(1, 3, 1), at(1, 4, 2), at(2, 0, 5), at(2, 1, 3), at(2, 2, 1), at(2, 3, 2), at(2, 4, 4), at(3, 0, 3), at(3, 1, 2), at(3, 2, 5), at(3, 3, 4), at(3, 4, 1), at(4, 0, 1), at(4, 1, 4), at(4, 2, 2), at(4, 3, 3), at(4, 4, 5)]),
      writeln(yes));
      writeln(no)).

test_assignment_3 :-
    writeln('%%%%%%% Assignment 3'),
    Sol = [at(4, 4, 5), at(4, 3, 3), at(4, 2, 2), at(4, 1, 4), at(4, 0, 1), at(3, 4, 1), at(3, 3, 4), at(3, 2, 5), at(3, 1, 2), at(3, 0, 3),
    at(2, 4, 4), at(2, 3, 2), at(2, 2, 1), at(2, 1, 3), at(2, 0, 5),
    at(1, 4, 2), at(1, 3, 1), at(1, 2, 3), at(1, 1, 5), at(1, 0, 4),
    at(0, 4, 3), at(0, 3, 5), at(0, 2, 4), at(0, 1, 1), at(0, 0, 2)],
    (findall(Isle, island(Sol, (1,0), Isle), [island([(1 ,0) ,(1 ,1) ,(2 ,0)])]) ->
      writeln(yes);
      writeln(no)).

% OPLOSSING VOOR OPDRACHT 4.1:
%    [light(0,4),light(1,0),light(2,6),light(3,5),light(5,3),light(6,2)]

:- loadfiles.
:- test_assignment_1.
:- test_assignment_2.
:- test_assignment_3.
:- halt.
